--- dia-0.85-0/lib/text.c	Sat Apr  8 01:22:32 2000
+++ dia-0.85-1/lib/text.c	Mon May 22 22:51:30 2000
@@ -507,6 +507,11 @@
     } else {
       return;
     }
+#ifdef USE_JAPANESE
+    if(text->line[row][i]<0) {
+      i++;
+    }
+#endif
   }
   text->cursor_pos = text->strlen[row];
 }
@@ -577,11 +582,27 @@
       text_join_lines(text, row);
     return;
   }
+#ifdef USE_JAPANESE
+  if(text->line[row][text->cursor_pos] > 0) {
+    memmove(text->line[row] + text->cursor_pos,
+           text->line[row] + text->cursor_pos + 1,
+           text->strlen[row] - text->cursor_pos);
+
+    text->strlen[row]--;
+  } else {
+    memmove(text->line[row] + text->cursor_pos,
+	    text->line[row] + text->cursor_pos + 2,
+	    text->strlen[row] - text->cursor_pos - 1);
+
+    text->strlen[row]-=2;
+  }
+#else
   memmove(text->line[row] + text->cursor_pos,
 	  text->line[row] + text->cursor_pos + 1,
 	  text->strlen[row] - text->cursor_pos);
 
   text->strlen[row]--;
+#endif
   
   if (text->cursor_pos > text->strlen[text->cursor_row])
     text->cursor_pos = text->strlen[text->cursor_row];
@@ -608,6 +629,22 @@
       text_join_lines(text, row-1);
     return;
   }
+#ifdef USE_JAPANESE
+  if(text->line[row][text->cursor_pos-1] > 0) {
+    memmove(text->line[row] + text->cursor_pos - 1,
+	    text->line[row] + text->cursor_pos,
+	    text->strlen[row] - text->cursor_pos + 1);
+    text->strlen[row]--;
+    
+    text->cursor_pos --;
+ } else {
+    memmove(text->line[row] + text->cursor_pos - 2,
+	    text->line[row] + text->cursor_pos,
+	    text->strlen[row] - text->cursor_pos + 2);
+    text->strlen[row]-=2;
+    text->cursor_pos -=2;
+  }
+#else
   memmove(text->line[row] + text->cursor_pos - 1,
 	  text->line[row] + text->cursor_pos,
 	  text->strlen[row] - text->cursor_pos + 1);
@@ -615,7 +652,7 @@
   text->strlen[row]--;
 
   text->cursor_pos --;
-  
+#endif  
   if (text->cursor_pos > text->strlen[text->cursor_row])
     text->cursor_pos = text->strlen[text->cursor_row];
 
@@ -719,6 +756,9 @@
   Text *text;
   int return_val;
   int row;
+#ifdef USE_JAPANESE
+  int i;
+#endif
 
   return_val = FALSE;
   *change = NULL;
@@ -749,12 +789,28 @@
     
     break;
   case GDK_Left:
+#ifdef JAPANESE
+    if(text->line[text->cursor_row][text->cursor_pos-1] > 0) {
+      text->cursor_pos--;
+    } else {
+      text->cursor_pos-=2;
+    }
+#else
     text->cursor_pos--;
+#endif
     if (text->cursor_pos<0)
       text->cursor_pos = 0;
     break;
   case GDK_Right:
+#ifdef JAPANESE
+    if(text->line[text->cursor_row][text->cursor_pos+1] > 0) {
+      text->cursor_pos++;
+    } else {
+      text->cursor_pos+=2;
+    }
+#else
     text->cursor_pos++;
+#endif
     if (text->cursor_pos > text->strlen[text->cursor_row])
       text->cursor_pos = text->strlen[text->cursor_row];
     break;
@@ -803,9 +859,17 @@
   default:
     if (strlen>0) {
       return_val = TRUE;
+#ifdef USE_JAPANESE
+      for(i = 0;i < strlen;i++) {
+        *change = text_create_change(text, TYPE_INSERT_CHAR, str[i],
+				     text->cursor_pos, text->cursor_row);
+        text_insert_char(text, str[i]);
+      }
+#else
       *change = text_create_change(text, TYPE_INSERT_CHAR, str[0],
 				   text->cursor_pos, text->cursor_row);
       text_insert_char(text, str[0]);
+#endif
     }
     break;
   }  
